/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WIDGETOPTIONS_H
#define WIDGETOPTIONS_H

#include "policesqt.h"
#include <QDialog>

#define min_temps_reflexion 10
#define max_temps_reflexion 300
#define min_nb_plaques 3
#define max_nb_plaques 6
#define min_min_compte 1
#define max_min_compte 100
#define min_max_compte 1
#define max_max_compte 999

class QGridLayout;
class QCheckBox;
class QSpinBox;

class WidgetOptions : public QDialog, policesQt {
  Q_OBJECT
	
  public:
	WidgetOptions( QWidget* parent = 0);
	
	QGridLayout *layout;
	QCheckBox* cano1, * cano2, * cano3;
	QSpinBox *boxTemps, *boxNbPlaque, *boxCompte, *boxCompte2;
	QPushButton* pbOk, * pbDefaut;
	
  public slots:
	void modifOk();
	void modifDefaut();
};

#endif
