/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WIDGETPLAQUE_H
#define WIDGETPLAQUE_H

#include <QWidget>

class QHBoxLayout;
class QVBoxLayout;
class QLCDNumber;
class QPushButton;

//Widget regroupant 1 Lcd et 2 pushbuttons pour les plaques
class WidgetPlaque : public QWidget {
	Q_OBJECT
	
  public: 
	WidgetPlaque( QWidget *parent=0, int numW=0, bool est_compteW=false); //constructeur
	
	//elements graphiques
	QVBoxLayout *vboxLayout;
	QLCDNumber *lcd;
	QWidget *hbox;
	QHBoxLayout *hboxLayout;
	QPushButton *pbMoins, *pbPlus;
	
	//dfinition des couleurs
	QPalette *palette_orange, *palette_blanc;
	
	//numero de widget
	int num;
	bool est_compte;
	
	private slots :
	void pbMoinsClicked();
	void pbPlusClicked();
	
	public slots :
	void displayRefresh(int numW, int valeur);
	
	signals :
	void change(int, bool); //prt  tre connect directement  plaque_change
};

#endif
