/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PRINCIPAL_H
#define PRINCIPAL_H

#include "tirage.h"
#include "jeu.h"
#include "widgetpopup.h"
#include "widgetplaque.h"
#include "widgethorloge.h"
#include "widgetoptions.h"
#include "policesqt.h"

#include <QMainWindow>
#include <QWidget>

//Dfinition des textes affichs
#define texte_renard_accueil "Kitsune - v1.1 - Bonjour !"
#define texte_renard_repos "Kitsune"
#define texte_renard_ceb "Le compte est bon !"
#define texte_renard_pds "Il n'y a pas de solution."
#define texte_statut_attente "En attente."
#define texte_statut_en_cours "Calcul en cours..."
#define texte_statut_duree "Dure du calcul : "

class QMenuBar;
class QMenu;
class QAction;

class QTextEdit;

class QHBoxLayout;
class QVBoxLayout;

class QLabel;
class QPixmap;
class QSpacerItem;

class Principal : public QMainWindow, policesQt {
	Q_OBJECT
	
  public:
	Principal( QWidget *parent=0 );

	//la classe jeu ne doit pas tre dtruite en sortie de resoudre (thread actif)
	jeu *J;
	
	//paramtres pour dterminer l'tat dans lequel se trouve l'application
	//sert  ne pas modifier le texte d'accueil,  l'ouverture de l'application
	bool demarrage;
	//true si un calcul est en train d'tre effectu
	bool calc_en_cours;
	//true si le tirage affich a t obtenu par pression sur le bouton "Alatoire" : il faut alors attendre avant d'afficher les solutions
	bool alea;
	//true si le calcul relatif au tirage affich, avec les options actuelles, a dj t effectu
	bool calc_resolu;
	
	//dfinition des widgets de la barre de menus
	QMenuBar *MenuBar;
	QMenu *fichierMenu, *infoMenu;
	
	//actions pour la barre de menus
	QAction *fileExitAction, *optionsAction, *helpAideAction, *helpLicenceAction, *helpAboutAction;
	
	//pour savoir combien de temps le calcul a pris
	QTime *heure;
	
	//widgets parents
	QWidget *hbox;
	QHBoxLayout *hboxLayout;
	
	QWidget *vboxA;
	QVBoxLayout *vboxLayoutA;
	QTextEdit *textEditB;
	
	//widgets de la colonne de gauche, disposs verticalement
	QWidget     *horLayout1,  *horLayout2,  *horLayout3, *horLayout4, *horLayout5;
	QHBoxLayout *hboxLayout1, *hboxLayout2, *hboxLayout3, *hboxLayout4, *hboxLayout5;
	QLabel *texte_renard;
	QStatusBar *BarreStatut;
	
	//widgets de la colonne de gauche, disposs horizontalement, par ligne
	QPushButton *pbRes, *pbAlea, *pbZero;
	QLabel *pixmapLabelRenard;
	QPixmap *renard_normal, *renard_heureux, *renard_triste;
	
	//divers espaces
	QSpacerItem *spacerItemH, *spacerItemV;
	
	//l'horloge pour afficher le temps restant
	WidgetHorloge *horloge;

	//divers paramtres
	tirage t;
	vector<plaque> liste_des_plaques;
	vector<int> liste_des_chiffres;
	
  public slots:
	
	//fonctions d'ouverture des fentres des menus
	void options();
	void helpAide();
	void helpLicence();
	void helpAbout();
	void lire_texte(int num);
	
	//une fonction pour mettre  jour l'affichage des plaques
	void update_affichage_plaques();
	void update_affichage_compte();
	void update_affichage_statut();
	
	//fonctions appeles lorsque l'on pousse un des 3 boutons
	void resoudre();
	void fin_calcul();
	void affiche_solutions();
	void aleatoire();
	void mise_a_zero();
	
	//fonctions appele  chaque modification du compte
	void compte_change(int,bool);
	
	//fonction appele  chaque modification d'une plaque
	void plaque_change(int,bool);
	
	//animation pour le mode aleatoire
	void anim();
  signals :
	//signal de rafraichissement
	void refresh(int, int); //num de widget a rafraichir et valeur
};

#endif
